Index: include/freeDiameter/libfdproto.h
===================================================================
--- include/freeDiameter/libfdproto.h	(revision 1343)
+++ include/freeDiameter/libfdproto.h	(revision 1392)
@@ -139,5 +139,5 @@
  *  ...		: Same list as printf
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  * Write information to log.
  * The format and arguments may contain UTF-8 encoded data. The
@@ -152,5 +152,5 @@
 #endif /* SWIG */
 
-/* these are internal objects of the debug facility, 
+/* these are internal objects of the debug facility,
 might be useful to control the behavior from outside */
 extern pthread_mutex_t	fd_log_lock;
@@ -164,5 +164,5 @@
  *  name 	: \0-terminated string containing a name to identify the current thread.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Name the current thread, useful for debugging multi-threaded problems.
  *
@@ -186,6 +186,6 @@
  *  incl_ms     : millisecond value is included in the output
  *
- * DESCRIPTION: 
- *  Writes the timestamp (in human readable format) in a buffer. 
+ * DESCRIPTION:
+ *  Writes the timestamp (in human readable format) in a buffer.
  *
  * RETURN VALUE:
@@ -246,5 +246,5 @@
 	char * function_name(char ** buf, size_t *len, size_t *offset)
 #endif /* SWIG */
-	
+
 
 /* Helper functions for the *dump functions that add into a buffer */
@@ -313,5 +313,5 @@
 
 /*
- * Use the following macros in the code to get traces with location & pid in debug mode: 
+ * Use the following macros in the code to get traces with location & pid in debug mode:
  */
 #ifdef DEBUG
@@ -403,10 +403,10 @@
  * The name "__ret__" is always available in the __fallback__ parameter and contains the error code.
  */
- 
+
 #define CHECK_PRELUDE(__call__) 			\
 		int __ret__; 				\
 		TRACE_CALL("Check: %s", #__call__ );	\
 		__ret__ = (__call__)
-	
+
 #define DEFAULT_FB	return __ret__;
 
@@ -492,5 +492,5 @@
 #ifndef SWIG
 static __inline__ void fd_log_deprecated( int level, const char *format, ... ) MARK_DEPRECATED
-{ 
+{
 	va_list ap;
 	va_start(ap, format);
@@ -558,5 +558,5 @@
 # define CHECK_POSIX( __call__ )	\
 		CHECK_POSIX_DO( (__call__), return __ret__ )
-		
+
 # define CHECK_MALLOC_DO( __call__, __fallback__ ) { 				   		       \
 	       void *  __ptr__; 								       \
@@ -572,5 +572,5 @@
 # define CHECK_MALLOC( __call__ )	\
 		CHECK_MALLOC_DO( (__call__), return __ret__ )
-	
+
 # define CHECK_PARAMS_DO( __bool__, __fallback__ ) {					       	       \
 	       TRACE_CALL("Check: %s", #__bool__ );						       \
@@ -589,5 +589,5 @@
 
 #endif /* EXCLUDE_DEPRECATED */
-	       
+
 
 /*============================================================*/
@@ -661,5 +661,5 @@
 
 /* Define the value of IP loopback address */
-#ifndef INADDR_LOOPBACK 
+#ifndef INADDR_LOOPBACK
 #define INADDR_LOOPBACK	inet_addr("127.0.0.1")
 #endif /* INADDR_LOOPBACK */
@@ -702,6 +702,6 @@
 # else /* HOST_BIG_ENDIAN */
     /* For these systems, we must reverse the bytes. Use ntohl and htonl on sub-32 blocs, and inverse these blocs. */
-#   define ntohll(x) (typeof (x))( (((uint64_t)ntohl( (uint32_t)(x))) << 32 ) | ((uint64_t) ntohl( ((uint64_t)(x)) >> 32 ))) 
-#   define htonll(x) (typeof (x))( (((uint64_t)htonl( (uint32_t)(x))) << 32 ) | ((uint64_t) htonl( ((uint64_t)(x)) >> 32 ))) 
+#   define ntohll(x) (typeof (x))( (((uint64_t)ntohl( (uint32_t)(x))) << 32 ) | ((uint64_t) ntohl( ((uint64_t)(x)) >> 32 )))
+#   define htonll(x) (typeof (x))( (((uint64_t)htonl( (uint32_t)(x))) << 32 ) | ((uint64_t) htonl( ((uint64_t)(x)) >> 32 )))
 # endif /* HOST_BIG_ENDIAN */
 #endif /* HAVE_NTOHLL */
@@ -727,5 +727,5 @@
 		(tsdiff)->tv_nsec = (tsend)->tv_nsec - (tsstart)->tv_nsec;		\
 	}}
-		
+
 
 /* This gives a good size for buffered reads */
@@ -756,10 +756,10 @@
 /*============================================================*/
 
-/* Compute a hash value of a binary string. 
+/* Compute a hash value of a binary string.
 The hash must remain local to this machine, there is no guarantee that same input
 will give same output on a different system (endianness) */
 uint32_t fd_os_hash ( uint8_t * string, size_t len );
 
-/* This type used for binary strings that contain no \0 except as their last character. 
+/* This type used for binary strings that contain no \0 except as their last character.
 It means some string operations can be used on it. */
 typedef uint8_t * os0_t;
@@ -787,5 +787,5 @@
 int fd_os_is_valid_DiameterIdentity(uint8_t * os, size_t ossz);
 
-/* The following function validates a string as a Diameter Identity or applies the IDNA transformation on it 
+/* The following function validates a string as a Diameter Identity or applies the IDNA transformation on it
  if *inoutsz is != 0 on entry, *id may not be \0-terminated.
  memory has the following meaning: 0: *id can be realloc'd. 1: *id must be malloc'd on output (was static)
@@ -793,5 +793,5 @@
 int fd_os_validate_DiameterIdentity(char ** id, size_t * inoutsz, int memory);
 
-/* Create an order relationship for binary strings (not needed to be \0 terminated). 
+/* Create an order relationship for binary strings (not needed to be \0 terminated).
    It does NOT mimic strings relationships so that it is more efficient. It is case sensitive.
    (the strings are actually first ordered by their lengh, then by their bytes contents)
@@ -800,9 +800,9 @@
 #define fd_os_cmp(_o1, _l1, _o2, _l2)  fd_os_cmp_int((os0_t)(_o1), _l1, (os0_t)(_o2), _l2)
 
-/* A roughly case-insensitive variant, which actually only compares ASCII chars (0-127) in a case-insentitive maneer 
+/* A roughly case-insensitive variant, which actually only compares ASCII chars (0-127) in a case-insentitive maneer
   -- it does not support locales where a lowercase letter uses more space than upper case, such as ß -> ss
  It is slower than fd_os_cmp.
  Note that the result is NOT the same as strcasecmp !!!
- 
+
  This function gives the same order as fd_os_cmp, except when it finds 2 strings to be equal.
  However this is not always sufficient:
@@ -817,6 +817,6 @@
 #define fd_os_almostcasesrch(_o1, _l1, _o2, _l2, _mb)  fd_os_almostcasesrch_int((os0_t)(_o1), _l1, (os0_t)(_o2), _l2, _mb)
 
-/* Analyze a DiameterURI and return its components. 
-  Return EINVAL if the URI is not valid. 
+/* Analyze a DiameterURI and return its components.
+  Return EINVAL if the URI is not valid.
   *diamid is malloc'd on function return and must be freed (it is processed by fd_os_validate_DiameterIdentity).
   *secure is 0 (no security) or 1 (security enabled) on return.
@@ -835,17 +835,17 @@
 {
 	void * th_ret = NULL;
-	
+
 	CHECK_PARAMS(th);
-	
+
 	/* Test if it was already terminated */
 	if (*th == (pthread_t)NULL)
 		return 0;
-	
+
 	/* Cancel the thread if it is still running - ignore error if it was already terminated */
 	(void) pthread_cancel(*th);
-	
+
 	/* Then join the thread */
 	CHECK_POSIX( pthread_join(*th, &th_ret) );
-	
+
 	if (th_ret == PTHREAD_CANCELED) {
 		TRACE_DEBUG(ANNOYING, "The thread %p was canceled", (void *)*th);
@@ -853,8 +853,8 @@
 		TRACE_DEBUG(CALL, "The thread %p returned %p", (void *)*th, th_ret);
 	}
-	
+
 	/* Clean the location */
 	*th = (pthread_t)NULL;
-	
+
 	return 0;
 }
@@ -862,5 +862,5 @@
 
 /*************
- Cancelation cleanup handlers for common objects 
+ Cancelation cleanup handlers for common objects
  *************/
 static __inline__ void fd_cleanup_mutex( void * mutex )
@@ -868,5 +868,5 @@
 	CHECK_POSIX_DO( pthread_mutex_unlock((pthread_mutex_t *)mutex), /* */);
 }
-		
+
 static __inline__ void fd_cleanup_rwlock( void * rwlock )
 {
@@ -946,5 +946,5 @@
 #define DICT_TYPE_MAX	DICT_RULE
 };
-	
+
 /* Initialize a dictionary */
 int fd_dict_init(struct dictionary ** dict);
@@ -958,11 +958,11 @@
  *  dict	: Pointer to the dictionnary where the object is created
  *  type 	: What kind of object must be created
- *  data 	: pointer to the data for the object. 
+ *  data 	: pointer to the data for the object.
  *          	 type parameter is used to determine the type of data (see below for detail).
  *  parent 	: a reference to a parent object, if needed.
  *  ref 	: upon successful creation, reference to new object is stored here if !null.
  *
- * DESCRIPTION: 
- *  Create a new object in the dictionary. 
+ * DESCRIPTION:
+ *  Create a new object in the dictionary.
  *  See following object sections in this header file for more information on data and parent parameters format.
  *
@@ -970,5 +970,5 @@
  *  0      	: The object is created in the dictionary.
  *  EINVAL 	: A parameter is invalid.
- *  EEXIST 	: This object is already defined in the dictionary (with conflicting data). 
+ *  EEXIST 	: This object is already defined in the dictionary (with conflicting data).
  *                If "ref" is not NULL, it points to the existing element on return.
  *  (other standard errors may be returned, too, with their standard meaning. Example:
@@ -988,6 +988,6 @@
  *  retval	: this value is returned if the object is not found and result is not NULL.
  *
- * DESCRIPTION: 
- *   Perform a search in the dictionary. 
+ * DESCRIPTION:
+ *   Perform a search in the dictionary.
  *   See the object-specific sections below to find how to look for each objects.
  *   If the "result" parameter is NULL, the function is used to check if an object is in the dictionary.
@@ -1013,5 +1013,5 @@
  *          	  The type is the same as "data" parameter in fd_dict_new function.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Retrieve content of a dictionary object.
  *  See following object sections in this header file for more information on data and parent parameters format.
@@ -1040,5 +1040,5 @@
  ***************************************************************************
  *
- * Vendor object 
+ * Vendor object
  *
  * These types are used to manage vendors in the dictionary
@@ -1070,7 +1070,7 @@
 On the other side, when value is retrieved with dict_getval, the string is not copied and MUST NOT be freed. It will
 be freed automatically along with the object itself with call to dict_fini later.
- 
+
 - fd_dict_new:
- The "parent" parameter is not used for vendors. 
+ The "parent" parameter is not used for vendors.
  Sample code to create a vendor:
  {
@@ -1091,5 +1091,5 @@
 	 ret = fd_dict_search ( dict, DICT_VENDOR, VENDOR_BY_NAME, "my vendor name", &vendor_found, ENOENT);
  }
- 
+
  - fd_dict_getval:
  Sample code to retrieve the data from a vendor object:
@@ -1102,14 +1102,14 @@
 	 printf("my vendor id: %d\n", myvendordata.vendor_id );
  }
-		 
+
 */
-		
+
 /* Special function: */
 uint32_t * fd_dict_get_vendorid_list(struct dictionary * dict);
-	 
+
 /*
  ***************************************************************************
  *
- * Application object 
+ * Application object
  *
  * These types are used to manage Diameter applications in the dictionary
@@ -1156,5 +1156,5 @@
 		 "my vendor's application"
 	 };
-	
+
 	 ret = fd_dict_new ( dict, DICT_VENDOR, &vendor_data, NULL, &vendor );
 	 ret = fd_dict_new ( dict, DICT_APPLICATION, &app_data, vendor, &appl );
@@ -1166,9 +1166,9 @@
 	 int ret;
 	 struct dict_object * vendor, * appli;
-	 
+
 	 ret = fd_dict_search ( dict, DICT_APPLICATION, APPLICATION_BY_NAME, "my vendor's application", &appli, ENOENT);
 	 ret = fd_dict_search ( dict, DICT_VENDOR, VENDOR_OF_APPLICATION, appli, &vendor, ENOENT);
  }
- 
+
  - fd_dict_getval:
  Sample code to retrieve the data from an application object:
@@ -1187,5 +1187,5 @@
  ***************************************************************************
  *
- * Type object 
+ * Type object
  *
  * These types are used to manage AVP data types in the dictionary
@@ -1194,5 +1194,5 @@
  */
 
-/* Type to store any AVP value */ 
+/* Type to store any AVP value */
 union avp_value {
 	struct {
@@ -1229,5 +1229,5 @@
  *   interpreted : The result of interpretation is stored here. The format and meaning depends on each type.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   This callback can be provided with a derived type in order to facilitate the interpretation of formated data.
  *  For example, when an AVP of type "Address" is received, it can be used to convert the octetstring into a struct sockaddr.
@@ -1246,9 +1246,9 @@
  *   val	: Pointer to the AVP value storage area where the data must be stored.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   This callback can be provided with a derived type in order to facilitate the encoding of formated data.
  *  For example, it can be used to convert a struct sockaddr in an AVP value of type Address.
  *  This callback is not called directly, but through the message's API msg_avp_value_encode function.
- *  If the callback is defined for an OctetString based type, the created string must be malloc'd. free will be called 
+ *  If the callback is defined for an OctetString based type, the created string must be malloc'd. free will be called
  *  automatically later.
  *
@@ -1265,10 +1265,10 @@
  *   val	: Pointer to the AVP value that was received and needs to be sanity checked.
  *   data      : a parameter stored in the type structure (to enable more generic check functions)
- *   error_msg: upon erroneous value, a string describing the error can be returned here (it will be strcpy by caller). This description will be returned in the error message, if any. 
- *
- * DESCRIPTION: 
+ *   error_msg: upon erroneous value, a string describing the error can be returned here (it will be strcpy by caller). This description will be returned in the error message, if any.
+ *
+ * DESCRIPTION:
  *   This callback can be provided with a derived type in order to improve the operation of the
  *  fd_msg_parse_dict function. When this callback is present, the value of the AVP that has
- * been parsed is passed to this function for finer granularity check. For example for some 
+ * been parsed is passed to this function for finer granularity check. For example for some
  * speccific AVP, the format of an OCTETSTRING value can be further checked, or the
  * interger value can be verified.
@@ -1301,5 +1301,5 @@
 
 /****
- Callbacks defined in libfdproto/dictionary_functions.c file -- see that file for usage. 
+ Callbacks defined in libfdproto/dictionary_functions.c file -- see that file for usage.
  */
 
@@ -1328,12 +1328,12 @@
 
 - fd_dict_new:
- The "parent" parameter may point to an application object, when a type is defined by a Diameter application. 
- 
+ The "parent" parameter may point to an application object, when a type is defined by a Diameter application.
+
  Sample code:
  {
 	 int ret;
 	 struct dict_object * mytype;
-	 struct dict_type_data mytypedata = 
-		{ 
+	 struct dict_type_data mytypedata =
+		{
 		 AVP_TYPE_OCTETSTRING,
 		 "Address",
@@ -1351,5 +1351,5 @@
 	 ret = fd_dict_search ( dict, DICT_TYPE, TYPE_BY_NAME, "Address", &address_type, ENOENT);
  }
- 
+
 */
 
@@ -1357,5 +1357,5 @@
  ***************************************************************************
  *
- * Enumerated values object 
+ * Enumerated values object
  *
  * These types are used to manage named constants of some AVP,
@@ -1382,5 +1382,5 @@
 	struct dict_object	*type_obj;
 	char *			 type_name;
-	
+
 	/* Search criteria for the constant */
 	struct dict_enumval_data search; /* search.enum_value is used only if search.enum_name == NULL */
@@ -1391,11 +1391,11 @@
 
 - fd_dict_new:
- The "parent" parameter must point to a derived type object. 
+ The "parent" parameter must point to a derived type object.
  Sample code to create a type "Boolean" with two constants "True" and "False":
  {
 	 int ret;
 	 struct dict_object * type_boolean;
-	 struct dict_type_data type_boolean_data = 
-		{ 
+	 struct dict_type_data type_boolean_data =
+		{
 		 AVP_TYPE_INTEGER32,
 		 "Boolean",
@@ -1416,5 +1416,5 @@
 	 ret = fd_dict_new ( dict, DICT_ENUMVAL, &boolean_false, type_boolean, NULL );
 	 ret = fd_dict_new ( dict, DICT_ENUMVAL, &boolean_true , type_boolean, NULL );
-	 
+
  }
 
@@ -1430,8 +1430,8 @@
 		 .search.enum_value.i32 = -1
 	 	};
-	 
+
 	 ret = fd_dict_search ( dict, DICT_ENUMVAL, ENUMVAL_BY_STRUCT, &boolean_by_value, &value_found, ENOENT);
  }
- 
+
  - fd_dict_getval:
  Sample code to retrieve the data from a constant object:
@@ -1446,5 +1446,5 @@
 		 .search.enum_value.i32 = 0
 	 	};
-	 
+
 	 ret = fd_dict_search ( dict, DICT_ENUMVAL, ENUMVAL_BY_STRUCT, &boolean_by_value, &value_found, ENOENT);
 	 ret = fd_dict_getval ( value_found, &boolean_data );
@@ -1452,9 +1452,9 @@
  }
 */
-	 
+
 /*
  ***************************************************************************
  *
- * AVP object 
+ * AVP object
  *
  * These objects are used to manage AVP definitions in the dictionary
@@ -1498,5 +1498,5 @@
 	AVP_BY_NAME_ALL_VENDORS,/* "what" points to a string. Might be quite slow... */
 	AVP_BY_STRUCT,		/* "what" points to a struct dict_avp_request_ex (see below) */
-			
+
 	/* kept for backward compatibility, better use AVP_BY_STRUCT above instead */
 	AVP_BY_CODE_AND_VENDOR,	/* "what" points to a struct dict_avp_request (see below), where avp_vendor and avp_code are set */
@@ -1512,5 +1512,5 @@
 		const char *			vendor_name;	/* set to NULL to ignore */
 	} avp_vendor;
-	
+
 	struct {
 		/* Only one of the following fields must be set */
@@ -1531,6 +1531,6 @@
  *  API usage :
 
-If "parent" parameter is not NULL during AVP creation, it must point to a DICT_TYPE object. 
-The extended type is then attached to the AVP. In case where it is an enumerated type, the value of 
+If "parent" parameter is not NULL during AVP creation, it must point to a DICT_TYPE object.
+The extended type is then attached to the AVP. In case where it is an enumerated type, the value of
 AVP is automatically interpreted in debug messages, and in message checks.
 The derived type of an AVP can be retrieved with: dict_search ( DICT_TYPE, TYPE_OF_AVP, avp, ... )
@@ -1561,12 +1561,12 @@
 		 AVP_TYPE_INTEGER32			// This MUST be the same as parent type's
 	 };
-	
+
  	 -- Create an AVP with a base type --
 	 ret = fd_dict_new ( dict, DICT_AVP, &user_name_data, NULL, &user_name_avp );
-	 
+
 	 -- Create an AVP with a derived type --
 	 ret = fd_dict_search ( dict, DICT_TYPE, TYPE_BY_NAME, "Boolean", &boolean_type, ENOENT);
 	 ret = fd_dict_new ( dict, DICT_AVP, &sample_boolean_data , boolean_type, &sample_boolean_avp );
-	 
+
  }
 
@@ -1582,14 +1582,14 @@
 		 .avp_name   = "Sample-Boolean"
 	 	};
-	 
+
 	 ret = fd_dict_search ( dict, DICT_AVP, AVP_BY_NAME, "User-Name", &avp_username, ENOENT);
-	 
+
 	 ret = fd_dict_search ( dict, DICT_AVP, AVP_BY_NAME_AND_VENDOR, &avpvendorboolean, &avp_sampleboolean, ENOENT);
 
 	 -- this would also work, but be slower, because it has to search all vendor dictionaries --
 	 ret = fd_dict_search ( dict, DICT_AVP, AVP_BY_NAME_ALL_VENDORS, "Sample-Boolean", &avp_sampleboolean, ENOENT);
-	 
+
  }
- 
+
  - fd_dict_getval:
  Sample code to retrieve the data from an AVP object:
@@ -1608,5 +1608,5 @@
  ***************************************************************************
  *
- * Command object 
+ * Command object
  *
  * These types are used to manage commands objects in the dictionary
@@ -1672,7 +1672,7 @@
 		 CMD_FLAG_REQUEST			// value. Only the "R" flag is constrained here, set.
 	 };
-	
+
 	 ret = fd_dict_new (dict,  DICT_COMMAND, &ce_data, NULL, &cer );
-	 
+
 	 ce_data.cmd_name = "Capabilities-Exchange-Answer";
 	 ce_data.cmd_flag_val = 0;			// Same constraint on "R" flag, but this time it must be cleared.
@@ -1690,5 +1690,5 @@
 	 ret = fd_dict_search ( dict, DICT_COMMAND, CMD_BY_CODE_R, &code, &cer, ENOENT);
  }
- 
+
  - fd_dict_getval:
  Sample code to retrieve the data from a command object:
@@ -1764,23 +1764,23 @@
 	struct dict_avp_data proxy_host_data = { 280, 0, "Proxy-Host", AVP_FLAG_VENDOR | AVP_FLAG_MANDATORY, AVP_FLAG_MANDATORY, AVP_TYPE_OCTETSTRING };
 	struct dict_avp_data proxy_state_data = { 33, 0, "Proxy-State",AVP_FLAG_VENDOR | AVP_FLAG_MANDATORY, AVP_FLAG_MANDATORY, AVP_TYPE_OCTETSTRING };
-	
+
 	-- Create the parent AVP
 	ret = fd_dict_new ( dict, DICT_AVP, &proxy_info_data, NULL, &proxy_info_avp );
-	
+
 	-- Create the first child AVP.
 	ret = fd_dict_new ( dict, DICT_TYPE, &di_type_data, NULL, &diameteridentity_type );
 	ret = fd_dict_new ( dict, DICT_AVP, &proxy_host_data, diameteridentity_type, &proxy_host_avp );
-	
+
 	-- Create the other child AVP
 	ret = fd_dict_new ( dict, DICT_AVP, &proxy_state_data, NULL, &proxy_state_avp );
-	
+
 	-- Now we can create the rules. Both children AVP are mandatory.
 	rule_data.rule_position = RULE_REQUIRED;
 	rule_data.rule_min = -1;
 	rule_data.rule_max = -1;
-	
+
 	rule_data.rule_avp = proxy_host_avp;
 	ret = fd_dict_new ( dict, DICT_RULE, &rule_data, proxy_info_avp, NULL );
-	
+
 	rule_data.rule_avp = proxy_state_avp;
 	ret = fd_dict_new ( dict, DICT_RULE, &rule_data, proxy_info_avp, NULL );
@@ -1790,5 +1790,5 @@
 
 */
-		
+
 /* Define some hard-coded values */
 /* Application */
@@ -1841,5 +1841,5 @@
 /* Error codes from Base protocol
 (reference: http://www.iana.org/assignments/aaa-parameters/aaa-parameters.xml#aaa-parameters-4)
-Note that currently, rfc3588bis-26 has some different values for some of these 
+Note that currently, rfc3588bis-26 has some different values for some of these
 */
 #define ER_DIAMETER_MULTI_ROUND_AUTH			1001
@@ -1909,5 +1909,5 @@
  *  opaque      : A pointer that is passed to the cleanup callback -- the content is never examined by the framework.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Create a new session handler. This is needed by a module to associate a state with a session object.
  * The cleanup handler is called when the session timeout expires, or fd_sess_destroy is called. It must free
@@ -1921,5 +1921,5 @@
 int fd_sess_handler_create ( struct session_handler ** handler, void (*cleanup)(struct sess_state * state, os0_t sid, void * opaque), session_state_dump dumper, void * opaque );
 
-	
+
 /*
  * FUNCTION:	fd_sess_handler_destroy
@@ -1929,5 +1929,5 @@
  *  opaque      : the opaque pointer registered with the callback is restored here (if ! NULL).
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  This destroys a session handler (typically called when an application is shutting down).
  * If sessions states are registered with this handler, the cleanup callback is called on them.
@@ -1952,5 +1952,5 @@
  *  optlen	  : if opt is \0-terminated, this can be 0. Otherwise, the length of opt.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Create a new session object. The Session-Id string associated with this session is generated as follow:
  *  If diamId parameter is provided, the string is created according to the RFC: <diamId>;<high32>;<low32>[;opt] where
@@ -1977,6 +1977,6 @@
  *  isnew	: if not NULL, set to 1 on return if the session object has been created, 0 if it was simply retrieved.
  *
- * DESCRIPTION: 
- *   Retrieve a session object from a Session-Id string. In case no session object was previously existing with this 
+ * DESCRIPTION:
+ *   Retrieve a session object from a Session-Id string. In case no session object was previously existing with this
  *  id, a new object is silently created (equivalent to fd_sess_new with flag SESSION_NEW_FULL).
  *
@@ -1989,5 +1989,5 @@
 
 /* only use the following in specific situations, e.g. app_radgw extension. They are normally handled by the framework only */
-int fd_sess_fromsid_msg ( uint8_t * sid, size_t len, struct session ** session, int * isnew); 
+int fd_sess_fromsid_msg ( uint8_t * sid, size_t len, struct session ** session, int * isnew);
 int fd_sess_ref_msg ( struct session * session );
 
@@ -1999,5 +1999,5 @@
  *  sid	  	: On success, the location of the sid is stored here.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Retrieve the session identifier (Session-Id) corresponding to a session object.
  *  The returned sid is a \0-terminated binary string which might be UTF-8 (but there is no guarantee in the framework).
@@ -2018,13 +2018,13 @@
  *  timeout	: The date when the session times out.
  *
- * DESCRIPTION: 
- *   Set the lifetime for a given session object. This function may be 
+ * DESCRIPTION:
+ *   Set the lifetime for a given session object. This function may be
  * called several times on the same object to update the timeout value.
- *   When the timeout date is reached, the cleanup handler of each 
- * module that registered data with this session is called, then the 
+ *   When the timeout date is reached, the cleanup handler of each
+ * module that registered data with this session is called, then the
  * session is cleared.
  *
  *   There is a possible race condition between cleanup of the session
- * and use of its data; applications should ensure that they are not 
+ * and use of its data; applications should ensure that they are not
  * using data from a session that is about to expire / expired.
  *
@@ -2041,8 +2041,8 @@
  *  session	: Pointer to a session object.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Destroys all associated states of a session, if any.
  * Equivalent to a session timeout expired, but the effect is immediate.
- * The session itself is marked as deleted, and will be freed when it is not referenced 
+ * The session itself is marked as deleted, and will be freed when it is not referenced
  * by any message anymore.
  *
@@ -2059,5 +2059,5 @@
  *  session	: Pointer to a session object.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Equivalent to fd_sess_destroy, only if no session_state is associated with the session.
  *  Otherwise, this function has no effect (except that it sets *session to NULL).
@@ -2080,5 +2080,5 @@
  *  state	: An application state (opaque data) to store with the session.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Stores an application state with a session. This state can later be retrieved
  * with fd_sess_state_retrieve, or implicitly in the cleanup handler when the session
@@ -2101,7 +2101,7 @@
  *  state	: Location where the state must be saved if it is found.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Retrieves a state saved by fd_sess_state_store.
- * After this function has been called, the state is no longer associated with 
+ * After this function has been called, the state is no longer associated with
  * the session. A new call to fd_sess_state_store must be performed in order to
  * store again the data with the session.
@@ -2111,5 +2111,5 @@
  *  EINVAL 	: A parameter is invalid.
  */
-int fd_sess_state_retrieve ( struct session_handler * handler, struct session * session, struct sess_state ** state ); 
+int fd_sess_state_retrieve ( struct session_handler * handler, struct session * session, struct sess_state ** state );
 
 
@@ -2125,5 +2125,5 @@
 /*============================================================*/
 
-/* The following functions are helpers for the routing module. 
+/* The following functions are helpers for the routing module.
   The routing data is stored in the message itself. */
 
@@ -2196,5 +2196,5 @@
 #define DIAMETER_VERSION	1
 
-/* In the two following types, some fields are marked (READONLY). 
+/* In the two following types, some fields are marked (READONLY).
  * This means that the content of these fields will be overwritten by the daemon so modifying it is useless.
  */
@@ -2239,5 +2239,5 @@
 #define AVPFL_SET_RAWDATA_FROM_AVP 0x02 /* When creating an AVP, initialize its rawdata area from an existing AVP -- it is only blank padding (for error reporting) */
 #define AVPFL_MAX		   AVPFL_SET_RAWDATA_FROM_AVP	/* The biggest valid flag value */
-	
+
 #define MSGFL_ALLOC_ETEID	0x01	/* When creating a message, a new end-to-end ID is allocated and set in the message */
 #define MSGFL_ANSW_ERROR	0x02	/* When creating an answer message, set the 'E' bit and use the generic error ABNF instead of command-specific ABNF */
@@ -2257,5 +2257,5 @@
  *  avp 	: Upon success, pointer to the new avp is stored here. It points to reference AVP upon function call when flags are used.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Create a new AVP instance.
  *
@@ -2276,6 +2276,6 @@
  *  msg 	: Upon success, pointer to the new message is stored here.
  *
- * DESCRIPTION: 
- *   Create a new empty Diameter message. 
+ * DESCRIPTION:
+ *   Create a new empty Diameter message.
  *
  * RETURN VALUE:
@@ -2296,5 +2296,5 @@
  *              : See other MSGFL_ANSW_* definition above for other flags.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   This function creates the empty answer message corresponding to a request.
  *  The header is set properly (R flag, ccode, appid, hbhid, eteid)
@@ -2318,5 +2318,5 @@
  *  depth	: If not NULL, points to an integer representing the "depth" of this object in the tree. This is a relative value, updated on return.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Explore the content of a message object (hierarchy). If "found" is null, only error checking is performed.
  *  If "depth" is provided, it is updated as follow on successful function return:
@@ -2329,5 +2329,5 @@
  *  0      	: found has been updated (if non NULL).
  *  EINVAL 	: A parameter is invalid.
- *  ENOENT	: No element has been found where requested, and "found" was NULL (otherwise, *found is set to NULL and 0 is returned). 
+ *  ENOENT	: No element has been found where requested, and "found" was NULL (otherwise, *found is set to NULL and 0 is returned).
  */
 int fd_msg_browse_internal ( msg_or_avp * reference, enum msg_brw_dir dir, msg_or_avp ** found, int * depth );
@@ -2345,7 +2345,7 @@
  *  avp         : pointer to the AVP object that must be inserted.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Adds an AVP into an object that can contain it: grouped AVP or message.
- * Note that the added AVP will be freed at the same time as the object it is added to, 
+ * Note that the added AVP will be freed at the same time as the object it is added to,
  * so it should not be freed after the call to this function.
  *
@@ -2364,5 +2364,5 @@
  *  avp		: location where the AVP reference is stored if found.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Search the first top-level AVP of a given model inside a message.
  * Note: only the first instance of the AVP is returned by this function.
@@ -2383,5 +2383,5 @@
  *  object      : pointer to the message or AVP object that must be unlinked and freed.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Unlink and free a message or AVP object and its children.
  *  If the object is an AVP linked into a message, the AVP is removed before being freed.
@@ -2407,5 +2407,5 @@
  *  recurse      : allow the function to go through the children objects if any to dump more information. might require parsing.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   These functions dump the content of a message or avp into a buffer
  * either recursively or only the object itself.
@@ -2432,5 +2432,5 @@
  *  model       : on success, pointer to the dictionary model of this command or AVP. NULL if the model is unknown.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Retrieve the dictionary object describing this message or avp. If the object is unknown or the fd_msg_parse_dict has not been called,
  *  *model is set to NULL.
@@ -2449,6 +2449,6 @@
  *  pdata 	: Upon success, pointer to the msg_hdr structure of this message. The fields may be modified.
  *
- * DESCRIPTION: 
- *   Retrieve location of modifiable section of a message. 
+ * DESCRIPTION:
+ *   Retrieve location of modifiable section of a message.
  *
  * RETURN VALUE:
@@ -2465,6 +2465,6 @@
  *  pdata 	: Upon success, pointer to the avp_hdr structure of this avp. The fields may be modified.
  *
- * DESCRIPTION: 
- *   Retrieve location of modifiable data of an avp. 
+ * DESCRIPTION:
+ *   Retrieve location of modifiable data of an avp.
  *
  * RETURN VALUE:
@@ -2482,5 +2482,5 @@
  *
  * DESCRIPTION:
- *  fd_msg_answ_associate associates a query msg with the received answer. 
+ *  fd_msg_answ_associate associates a query msg with the received answer.
  * Query is retrieved with fd_msg_answ_getq.
  * If answer message is freed, the query is also freed.
@@ -2543,6 +2543,6 @@
  *  msg		: A msg object.
  *
- * DESCRIPTION: 
- *   This function returns a boolean telling if a given message is routable in the Diameter network, 
+ * DESCRIPTION:
+ *   This function returns a boolean telling if a given message is routable in the Diameter network,
  *  or if it is a local link message only (ex: CER/CEA, DWR/DWA, ...).
  *
@@ -2561,5 +2561,5 @@
  *  dict	: a dictionary with definition of Route-Record AVP (for fd_msg_source_setrr)
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Store or retrieve the diameted id of the peer from which this message was received.
  * Will be used for example by the routing module to add the Route-Record AVP in forwarded requests,
@@ -2580,5 +2580,5 @@
  *  -
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Get a new unique end-to-end id value for the local peer.
  *
@@ -2630,9 +2630,9 @@
  * PARAMETERS:
  *  avp 	: Pointer to a valid avp object with a NULL avp_value pointer. The model must be known.
- *  value 	: pointer to an avp_value. The content will be COPIED into the internal storage area. 
+ *  value 	: pointer to an avp_value. The content will be COPIED into the internal storage area.
  *		 If data type is an octetstring, the data is also copied.
  * 		 If value is a NULL pointer, the previous data is erased and value is unset in the AVP.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Initialize the avp_value field of an AVP header.
  *
@@ -2651,5 +2651,5 @@
  *		 This is only valid for AVPs of derived type for which type_data_encode callback is set. (ex: Address type)
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Initialize the avp_value field of an AVP object from formatted data, using the AVP's type "type_data_encode" callback.
  *
@@ -2667,7 +2667,7 @@
  *  data 	: Upon success, formatted interpretation of the AVP value is stored here.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Interpret the content of an AVP of Derived type and store the result in data pointer. The structure
- * of the data pointer is dependent on the AVP type. This function calls the "type_data_interpret" callback 
+ * of the data pointer is dependent on the AVP type. This function calls the "type_data_interpret" callback
  * of the type.
  *
@@ -2688,10 +2688,10 @@
  *
  * PARAMETERS:
- *  msg		: A valid msg object. All AVPs must have a value set. 
- *  buffer 	: Upon success, this points to a buffer (malloc'd) containing the message ready for network transmission (or security transformations). 
+ *  msg		: A valid msg object. All AVPs must have a value set.
+ *  buffer 	: Upon success, this points to a buffer (malloc'd) containing the message ready for network transmission (or security transformations).
  *		 The buffer may be freed after use.
  *  len		: if not NULL, the size of the buffer is written here. In any case, this size is updated in the msg header.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Renders a message in memory as a buffer that can be sent over the network to the next peer.
  *
@@ -2707,9 +2707,9 @@
  *
  * PARAMETERS:
- *  buffer 	: Pointer to a buffer containing a message received from the network. 
+ *  buffer 	: Pointer to a buffer containing a message received from the network.
  *  buflen	: the size in bytes of the buffer.
  *  msg		: Upon success, this points to a valid msg object. No AVP value is resolved in this object, nor grouped AVP.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   This function parses a buffer an creates a msg object to represent the structure of the message.
  *  Since no dictionary lookup is performed, the values of the AVPs are not interpreted. To interpret the values,
@@ -2742,10 +2742,10 @@
  *  error_info	: If not NULL, will contain the detail about error upon return. May be used to generate an error reply.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   This function looks up for the command and each children AVP definitions in the dictionary.
  *  If the dictionary definition is found, avp_model is set and the value of the AVP is interpreted accordingly and:
  *   - for grouped AVPs, the children AVP are created and interpreted also.
  *   - for numerical AVPs, the value is converted to host byte order and saved in the avp_value field.
- *   - for octetstring AVPs, the string is copied into a new buffer and its address is saved in avp_value. 
+ *   - for octetstring AVPs, the string is copied into a new buffer and its address is saved in avp_value.
  *  If the dictionary definition is not found, avp_model is set to NULL and
  *  the content of the AVP is saved as an octetstring in an internal structure. avp_value is NULL.
@@ -2768,5 +2768,5 @@
  *  error_info	: If not NULL, the first problem information will be saved here.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Check that the children of the object do not conflict with the dictionary rules (ABNF compliance).
  *
@@ -2785,7 +2785,7 @@
  *
  * PARAMETERS:
- *  object 	: Pointer to a valid msg or avp. 
- *
- * DESCRIPTION: 
+ *  object 	: Pointer to a valid msg or avp.
+ *
+ * DESCRIPTION:
  *   Update the length field of the object passed as parameter.
  * As a side effect, all children objects are also updated. Therefore, all avp_value fields of
@@ -2889,5 +2889,5 @@
  * DISP_HOW_AVP_ENUMVAL.
  *  All fields have the same constraints and meaning as in DISP_REG_AVP. In addition, the "value" field must be set
- *  and points to a valid DICT_ENUMVAL object. 
+ *  and points to a valid DICT_ENUMVAL object.
  *
  * Here is a sumary of the fields: ( M : must be set; m : may be set; 0 : ignored )
@@ -2916,5 +2916,5 @@
  *  action	: upon return, this tells the daemon what to do next.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Called when a received message matchs the condition for which the callback was registered.
  * This callback may do any kind of processing on the message, including:
@@ -2923,5 +2923,5 @@
  *  - update a routing table or start a connection with a new peer, then forward the message.
  *  - ...
- * 
+ *
  * When *action == DISP_ACT_SEND on callback return, the msg pointed by *msg is passed to the routing module for sending.
  * When *action == DISP_ACT_CONT, the next registered callback is called.
@@ -2946,8 +2946,8 @@
  *  when          : Values that must match, depending on the how argument.
  *  opaque        : A pointer that is passed back to the handler. The content is not interpreted by the framework.
- *  handle        : On success, a handler to the registered callback is stored here if not NULL. 
+ *  handle        : On success, a handler to the registered callback is stored here if not NULL.
  *		   This handler can be used to unregister the cb.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Register a new callback to handle messages delivered locally.
  *
@@ -2957,5 +2957,5 @@
  *  ENOMEM	: Not enough memory to complete the operation
  */
-int fd_disp_register ( int (*cb)( struct msg **, struct avp *, struct session *, void *, enum disp_action *), 
+int fd_disp_register ( int (*cb)( struct msg **, struct avp *, struct session *, void *, enum disp_action *),
 			enum disp_how how, struct disp_when * when, void * opaque, struct disp_hdl ** handle );
 
@@ -2967,5 +2967,5 @@
  *  opaque       : If not NULL, the opaque data that was registered is restored here.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Removes a callback previously registered by fd_disp_register.
  *
@@ -2990,5 +2990,5 @@
  *  drop_msg    : if drop_reason is set, this points to the message to be freed while *msg is NULL.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *   Call all handlers registered for a given message.
  *  The session must have already been resolved on entry.
@@ -3022,5 +3022,5 @@
  *		  blocking operation. Use 0 to disable this maximum.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Create a new empty queue.
  *
@@ -3028,5 +3028,5 @@
  *  0		: The queue has been initialized successfully.
  *  EINVAL 	: The parameter is invalid.
- *  ENOMEM	: Not enough memory to complete the creation.  
+ *  ENOMEM	: Not enough memory to complete the creation.
  */
 int fd_fifo_new ( struct fifo ** queue, int max );
@@ -3038,5 +3038,5 @@
  *  queue	: Pointer to an empty queue to delete.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Destroys a queue. This is only possible if no thread is waiting for an element,
  * and the queue is empty.
@@ -3056,5 +3056,5 @@
  *  loc_update	: if non NULL, a place to store the pointer to new FIFO atomically with the move.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Empties a queue and move its content to another one atomically.
  *
@@ -3077,6 +3077,6 @@
  *  blocking      : Cumulated time threads trying to post new items were blocked (queue full).
  *  last          : For the last element retrieved from the queue, how long it take between posting (including blocking) and poping
- *  
- * DESCRIPTION: 
+ *
+ * DESCRIPTION:
  *  Retrieve the timing information associated with a queue, for monitoring purpose.
  *
@@ -3085,5 +3085,5 @@
  *  EINVAL 	: A parameter is invalid.
  */
-int fd_fifo_getstats( struct fifo * queue, int * current_count, int * limit_count, int * highest_count, long long * total_count, 
+int fd_fifo_getstats( struct fifo * queue, int * current_count, int * limit_count, int * highest_count, long long * total_count,
 				           struct timespec * total, struct timespec * blocking, struct timespec * last);
 
@@ -3094,5 +3094,5 @@
  *  queue	: The queue from which to retrieve the number of elements.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  Retrieve the number of elements in a queue, without error checking.
  *
@@ -3113,5 +3113,5 @@
  *  l_cb        : If the number of elements decrease to low, this callback is called.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  This function allows to adjust the number of producer / consumer threads of a queue.
  * If the consumer are slower than the producers, the number of elements in the queue increase.
@@ -3142,5 +3142,5 @@
  *  item	: The element that is put in the queue.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  An element is added in a queue. Elements are retrieved from the queue in FIFO order
  *  with the fd_fifo_get, fd_fifo_tryget, or fd_fifo_timedget functions.
@@ -3166,7 +3166,7 @@
  *  item	: On return, the first element of the queue is stored here.
  *
- * DESCRIPTION: 
- *  This function retrieves the first element from a queue. If the queue is empty, the function will block the 
- * thread until a new element is posted to the queue, or until the thread is canceled (in which case the 
+ * DESCRIPTION:
+ *  This function retrieves the first element from a queue. If the queue is empty, the function will block the
+ * thread until a new element is posted to the queue, or until the thread is canceled (in which case the
  * function does not return).
  *
@@ -3186,6 +3186,6 @@
  *  item	: On return, the first element of the queue is stored here.
  *
- * DESCRIPTION: 
- *  This function is similar to fd_fifo_get, except that it will not block if 
+ * DESCRIPTION:
+ *  This function is similar to fd_fifo_get, except that it will not block if
  * the queue is empty, but return EWOULDBLOCK instead.
  *
@@ -3207,6 +3207,6 @@
  *  abstime	: the absolute time until which we allow waiting for an item.
  *
- * DESCRIPTION: 
- *  This function is similar to fd_fifo_get, except that it will block if the queue is empty 
+ * DESCRIPTION:
+ *  This function is similar to fd_fifo_get, except that it will block if the queue is empty
  * only until the absolute time abstime (see pthread_cond_timedwait for + info).
  * If the queue is still empty when the time expires, the function returns ETIMEDOUT
@@ -3229,5 +3229,5 @@
  *  abstime	: the absolute time until which we can block waiting for an item. If NULL, the function returns immediatly.
  *
- * DESCRIPTION: 
+ * DESCRIPTION:
  *  This function is similar to select(), it waits for data to be available in the queue
  * until the abstime is expired.
